$! 03-JUL-98  MGD  support SSLeay 0.9.0b
$! 27-JUN-98  MGD  changes to support building executables on site
$! 08-FEB-98  MGD  modified for 0_8_1 and WASD HTTPd
$!
$! This procedure compiles the SSL sources into 2 libraries:
$!	[.CRYPTO]CRYPTO-xxx.OLB		! crypto-graphics subroutines
$!	[.SSL]SSL-xxx.OLB		! SSL protocol.
$!
$!  where 'xxx' specifies the machine achitecture: AXP or VAX
$!
$!  To perform 1 sub-option, specify P1 as one of:
$!	INCLUDE CRYPTO SSL APPS
$!
$!  Requirements:
$!	DECC 4.0   	(may work with other versions)
$!	OpenVMS 6.1	(may work with other versions)
$!
$! 03-JUL-98 MGD
$ CC = "CC/NODEBUG/NOMEMBER_ALIGN/NOOPTIMIZE/NOWARN" +-
       "/DEFINE=(_VMS_V6_SOURCE,__VMS_VER=60000000,__CRTL_VER=60000000,VMS)"
$ DEFINE /JOB DECC$USER_INCLUDE HT_ROOT:[SRC.SSLEAY-0_9_0B...]
$! end MGD
$ original_default = f$environment("DEFAULT")
$ proc = f$environment("PROCEDURE")
$ proc_dir = f$parse("1.1;1",proc) - "1.1;1"
$ set default 'proc_dir'
$!
$! Copy all include files to [.include]
$!
$ set noon
$ if P1 .nes. "" then goto do_'p1'
$! 03-JUL-98 MGD
$! do_include
$! do_include:
$! write sys$output "Rebuilding [.include] directory..."
$! delete [.include]*.h;*
$! backup [.*...]*.h; includes.bck/save
$! backup includes.bck/save [.include]
$! delete includes.bck;
$! if p1 .nes. "" then goto cleanup
$! end MGD
$!
$! Build crypto lib.
$!
$ do_crypto:
$ write sys$Output "Making CRYPTO library"
$ set default [.crypto]
$ @libvms
$ set default [-]
$ if p1 .nes. "" then goto cleanup
$!
$! Build SSL lib.
$!
$ do_ssl:
$ write sys$output "Making SSL library"
$ set default [.ssl]
$ libname = "ssl-axp.olb"
$ if f$getsyi("CPU") .lt. 128 then libname = "ssl-vax.olb"
$ if f$search(libname) .eqs. "" then library/create/log 'libname'
$ cc ssl.c/include=[-.include]/prefix=all
$ library/replace 'libname' ssl.obj
$ set default [-]
$ if p1 .nes. "" then goto cleanup
$!
$! 03-JUL-98 MGD
$ DELETE /NOLOG [...]*.SUBSET;*
$ DELETE /NOLOG [SRC.SSLEAY-0_9_1B...]*.OBJ;* -
         /EXCLUDE=[SRC.SSLEAY-0_9_1B.APPS]*.OBJ;*
$! end MGD
$ GOTO CLEANUP
$!
$! 03-JUL-98 MGD
$ DO_APPS:
$ DO_LINK:
$ LIBNAME = "[-.SSL]SSL-AXP.OLB"
$ IF F$GETSYI("CPU") .LT. 128 THEN LIBNAME = "[-.SSL]SSL-VAX.OLB"
$ CRYPTOLIB = "[-.CRYPTO]CRYPTO-" + F$ELEMENT(2,"-",LIBNAME)
$ SET DEFAULT [.APPS]
$ ARCH = "AXP"
$ IF F$GETSYI("CPU") .LT. 128 THEN ARCH = "VAX"
$ IF P1 .NES. "LINK"
$ THEN
$    WRITE SYS$OUTPUT ""
$    WRITE SYS$OUTPUT "Compiling SSLeay applications"
$    CC APPS.C/PREFIX=ALL/OBJ=APPS_'ARCH'.OBJ
$    CC CA.C/PREFIX=ALL/OBJ=CA_'ARCH'.OBJ
$    CC CRL.C/PREFIX=ALL/OBJ=CRL_'ARCH'.OBJ
$    CC CRL2P7.C/PREFIX=ALL/OBJ=CRL2P7_'ARCH'.OBJ
$    CC GENRSA.C/PREFIX=ALL/OBJ=GENRSA_'ARCH'.OBJ
$    CC REQ.C/PREFIX=ALL/OBJ=REQ_'ARCH'.OBJ
$    CC RSA.C/PREFIX=ALL/OBJ=RSA_'ARCH'.OBJ
$    CC X509.C/PREFIX=ALL/OBJ=X509_'ARCH'.OBJ
$    CC VERIFY.C/PREFIX=ALL/OBJ=VERIFY_'ARCH'.OBJ
$    PURGE/NOLOG *.OBJ
$    SET PROT=W:RE *.OBJ
$ ENDIF
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT "Linking SSLeay applications"
$ LINK_TO_THIS = "APPS_'ARCH','LIBNAME'/LIBRARY,'CRYPTOLIB'/LIBRARY"
$ LINK /EXEC=CA_'ARCH'.EXE CA_'ARCH','LINK_TO_THIS'
$ LINK /EXEC=CRL_'ARCH'.EXE CRL_'ARCH','LINK_TO_THIS'
$ LINK /EXEC=CRL2P7_'ARCH'.EXE CRL2P7_'ARCH','LINK_TO_THIS'
$ LINK /EXEC=GENRSA_'ARCH'.EXE GENRSA_'ARCH','LINK_TO_THIS'
$ LINK /EXEC=REQ_'ARCH'.EXE REQ_'ARCH','LINK_TO_THIS'
$ LINK /EXEC=RSA_'ARCH'.EXE RSA_'ARCH','LINK_TO_THIS'
$ LINK /EXEC=X509_'ARCH'.EXE X509_'ARCH','LINK_TO_THIS'
$ LINK /EXEC=VERIFY_'ARCH'.EXE VERIFY_'ARCH','LINK_TO_THIS'
$ SET PROT=W:RE *.EXE
$ GOTO CLEANUP
$! end MGD
$!
$ cleanup:
$! 03-JUL-98 MGD
$ DEASSIGN /JOB DECC$USER_INCLUDE
$! end MGD
$ set default 'original_default'
$ write sys$output "Done"
