$!-----------------------------------------------------------------------------
$! CA.COM
$!
$! Let's be our own certificate authority!
$! This procedure is very "quick-and-dirty", use with that in mind!
$!
$! CREATE FOREIGN VERBS
$! --------------------
$! Symbols assigned: CA, CRL, CRL2P7, GENRSA, REQ, RSA, VERIFY, X509
$! P1 == "SYMBOLS" or "SYM" or even nothing (that generates usage infomation!)
$!
$! CREATE CA CERTIFICATE
$! ---------------------
$! creates a "certificate authority" certificate
$! P1 == "CA"
$! P2 == optional configuration file (defaults to WASD.CNF)
$!
$! CREATE SERVER CERTIFICATE
$! -------------------------
$! P1 == "SERVER"
$! P2 == 'certificate-name'
$! P3 == optional configuration file (defaults to WASD.CNF)
$!
$! RESET CERTIFICATE DATABASE
$! --------------------------
$! deletes all certificate information (except CA) ... CAUTION!
$! P1 == "RESET"
$!
$! 03-JUL-98  MGD  SSLeay 0.9.0b
$! 26-FEB-98  MGD  added other utilities and associated symbol assignments
$! 08-FEB-98  MGD  initial (q&d)
$!-----------------------------------------------------------------------------
$!
$!(5 * 365 == valid for five years!)
$ DAYS = 1825
$!
$ SAY = "WRITE SYS$OUTPUT"
$!
$ ARCH = "AXP"
$ IF F$GETSYI("CPU") .LT. 128 THEN ARCH = "VAX"
$!
$ CA      == "$HT_ROOT:[SRC.SSLEAY-0_9_0B.APPS]CA_''ARCH'.EXE"
$ CRL     == "$HT_ROOT:[SRC.SSLEAY-0_9_0B.APPS]CRL_''ARCH'.EXE"
$ CRL2P7  == "$HT_ROOT:[SRC.SSLEAY-0_9_0B.APPS]CRL2P7_''ARCH'.EXE"
$ GENRSA  == "$HT_ROOT:[SRC.SSLEAY-0_9_0B.APPS]GENRSA_''ARCH'.EXE"
$ REQ     == "$HT_ROOT:[SRC.SSLEAY-0_9_0B.APPS]REQ_''ARCH'.EXE"
$ RSA     == "$HT_ROOT:[SRC.SSLEAY-0_9_0B.APPS]RSA_''ARCH'.EXE"
$ VERIFY  == "$HT_ROOT:[SRC.SSLEAY-0_9_0B.APPS]VERIFY_''ARCH'.EXE"
$ X509    == "$HT_ROOT:[SRC.SSLEAY-0_9_0B.APPS]X509_''ARCH'.EXE"
$!
$ IF P1 .EQS. "SYMBOLS" .OR. P1 .EQS. "SYM" THEN EXIT
$!
$ IF P1 .EQS. "CA" THEN GOTO CA
$ IF P1 .EQS. "SERVER" THEN GOTO SERVER
$ IF P1 .EQS. "RESET"
$ THEN
$    PREVIOUS_DEFAULT = F$ENVIRONMENT("DEFAULT")
$    SET DEFAULT HT_ROOT:[SRC.SSLEAY-0_9_0B.WASD]
$    DELETE /NOLOG SERIAL.*;*,INDEX.*;*,%%.PEM;*
$    IF P2 .EQS. "CA" THEN DELETE /NOLOG CA*.PEM;*,CA*.CRT;*
$    SET DEFAULT 'PREVIOUS_DEFAULT'
$    EXIT
$ ENDIF
$ SAY ""
$ SAY "To create a new CA certificate and key: " +-
      """$ @CA CA [config-file]"""
$ SAY "To issue a server certificate: " +-
      """$ @CA SERVER server-name [config-file]"""
$ SAY ""
$ EXIT
$!
$!-----------------------------------------------------------------------------
$!
$ CA:
$!
$ GOSUB NOTE
$!
$ IF P2 .EQS. "" THEN P2 = "WASD.CNF"
$ IF F$PARSE(P2,,,"TYPE") .EQS. "." THEN P2 = P2 + ".CNF"
$!
$ ON ERROR THEN GOTO CA_CLEANUP
$ PREVIOUS_DEFAULT = F$ENVIRONMENT("DEFAULT")
$ SET DEFAULT HT_ROOT:[SRC.SSLEAY-0_9_0B.WASD]
$!
$ GOSUB SUPPORT_FILES
$!
$ SAY ""
$ SAY "***** CREATE NEW CA CERTIFICATE (remember the PEM pass phrase!) *****"
$ SAY ""
$ DEFINE /USER SYS$INPUT SYS$COMMAND
$ REQ -days 'DAYS' -verify -new -x509 -config 'P2' -
      -outform PEM -out CACERT.PEM -keyout CAKEY.PEM
$ SAY ""
$ SAY "***** CREATING DER VERSION *****"
$ SAY ""
$ DEFINE /USER SYS$INPUT SYS$COMMAND
$ X509 -inform PEM -outform DER -in CACERT.PEM -out CACERT.CRT
$ SAY ""
$!
$ CA_CLEANUP:
$ SAY ""
$ SAY "***** FINISHED *****"
$ SAY ""
$ SAY "New CA certificates and key, " +-
      "CACERT.PEM, CACERT.DER and CAKEY.PEM created"
$ SAY ""
$ DEFINE /USER SYS$OUTPUT NL:
$ DEFINE /USER SYS$ERROR NL:
$ DELETE *.;*,*.;*
$ DEFINE /USER SYS$OUTPUT NL:
$ DEFINE /USER SYS$ERROR NL:
$ PURGE /NOLOG /KEEP=1 SERIAL.*,INDEX.*,WASD.RND
$ SET PROT=W *.*
$ SET PROT=W:RE CA.COM
$ SET PROT=W:RE CACERT.PEM
$ SET PROT=W:RE CACERT.CRT
$ SET DEFAULT 'PREVIOUS_DEFAULT'
$ EXIT
$!
$!-----------------------------------------------------------------------------
$!
$ SERVER:
$!
$ IF P2 .EQS. ""
$ THEN
$    SAY "P2 must be the name of the certificate file."
$    EXIT
$ ENDIF
$ IF F$PARSE(P2,,,"TYPE") .EQS. "." THEN P2 = P2 + ".PEM"
$!
$ IF P3 .EQS. "" THEN P3 = "WASD.CNF"
$ IF F$PARSE(P3,,,"TYPE") .EQS. "." THEN P3 = P3 + ".CNF"
$!
$ GOSUB NOTE
$!
$ ON ERROR THEN GOTO SERVER_CLEANUP
$ PREVIOUS_DEFAULT = F$ENVIRONMENT("DEFAULT")
$ SET DEFAULT HT_ROOT:[SRC.SSLEAY-0_9_0B.WASD]
$!
$ GOSUB SUPPORT_FILES
$!
$ SAY ""
$ SAY "***** NOTE: the standard WASD CA PEM pass phrase is ""testing"" *****"
$ SAY ""
$ DEFINE /USER SYS$INPUT SYS$COMMAND
$ REQ -newkey rsa:512 -verify -new -config 'P3' -
      -outform PEM -out TMPREQ.PEM -keyout TMPKEY1.PEM
$!
$ SAY ""
$ SAY "***** SIGN CERTIFICATE *****"
$ SAY ""
$ DEFINE /USER SYS$INPUT SYS$COMMAND
$ CA -days 'DAYS' -policy policy_anything -config 'P3' -
     -outdir ./ -out TMPCERT.PEM -infiles TMPREQ.PEM
$!
$ SAY ""
$ SAY "Check for error or report of ""matching entry"""
$ READ SYS$COMMAND LINE -
       /ERROR=SERVER_CLEANUP /END=SERVER_CLEANUP -
       /PROMPT="Continue if no matching entry [N]: "
$ IF .NOT. LINE THEN GOTO SERVER_CLEANUP
$!
$ SAY ""
$ SAY "***** STRIP PEM PHRASE *****"
$ SAY ""
$ DEFINE /USER SYS$INPUT SYS$COMMAND
$ RSA -in TMPKEY1.PEM -out TMPKEY2.PEM
$!
$ SAY ""
$ SAY "***** APPENDING KEY TO CERTIFICATE *****"
$ COPY TMPCERT.PEM,TMPKEY2.PEM 'P2'
$!
$ SERVER_CLEANUP:
$ SAY ""
$ SAY "***** FINISHED *****"
$ SAY ""
$ SAY "New server certificate is ''P2'"
$ SAY ""
$ DELETE /NOLOG TMP*.PEM;*
$ DEFINE /USER SYS$OUTPUT NL:
$ DEFINE /USER SYS$ERROR NL:
$ DELETE *.;*,*.;*
$ DEFINE /USER SYS$OUTPUT NL:
$ DEFINE /USER SYS$ERROR NL:
$ PURGE /NOLOG /KEEP=1 SERIAL.*,INDEX.*,WASD.RND
$ SET PROT=W *.*
$ SET PROT=W:RE CA.COM
$ SET PROT=W:RE CACERT.PEM
$ SET PROT=W:RE CACERT.CRT
$ SET DEFAULT 'PREVIOUS_DEFAULT'
$ EXIT
$!
$!-----------------------------------------------------------------------------
$!
$ SUPPORT_FILES:
$!
$ IF F$SEARCH("WASD.RND") .EQS. ""
$ THEN
$    OPEN /WRITE RND WASD.RND
$    WRITE RND F$CVTIME()
$    CLOSE RND
$    PURGE /NOLOG WASD.RND
$ ENDIF
$!
$ IF F$SEARCH("INDEX.NEW") .NES. "" THEN COPY INDEX.NEW INDEX.;
$ IF F$SEARCH("INDEX.;") .EQS. ""
$ THEN
$    CREATE INDEX.; /FDL=STMLF.FDL
$ ENDIF
$!
$ IF F$SEARCH("SERIAL.NEW") .NES. "" THEN COPY SERIAL.NEW SERIAL.;
$ IF F$SEARCH("SERIAL.;") .EQS. ""
$ THEN
$    CREATE SERIAL.; /FDL=STMLF.FDL 
$    OPEN /APPEND FILE SERIAL.;
$    WRITE FILE "01"
$    CLOSE FILE
$ ENDIF
$!
$ RETURN
$!
$!-----------------------------------------------------------------------------
$!
$ NOTE:
$!
$ SAY ""
$ SAY "--NOTE--NOTE--NOTE--NOTE--"
$ SAY ""
$ SAY "  keep the certificate fields as short as practicable"
$ SAY "  (see comments in WASD.CNF)"
$ SAY ""
$ SAY "--NOTE--NOTE--NOTE--NOTE--"
$!
$ RETURN
$!
$!-----------------------------------------------------------------------------
